/* Name: ADC.c
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
 
 
#include <stdlib.h>
#include <avr/wdt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <compat/deprecated.h>



#include "main.h"
#include "I_O_hardware.h"


ISR(ADC_vect)
{
static uint8_t StepMeasure,SetInputsMeasure,IdleCircle=1;
register uint8_t o,p;
uint16_t DigitADC;


	

o=ADCL;
p=ADCH;
DigitADC=p*0x100+o;
if (IdleCircle==0)
	{
	
	if (StepMeasure>2) StepMeasure=0;
	else StepMeasure++;
	
	if (StepMeasure==0)
		{
		ADMUX=0x43;
		if (SetInputsMeasure==0)
			{
			
			
			data.AccumCurrent=DigitADC;
			
			}
		if (SetInputsMeasure==1)
			{
			data.JumperVoltage=DigitADC;
			}
		if (SetInputsMeasure==2)
			{
			data.AccumVoltage=DigitADC;
			}
		if (SetInputsMeasure==3)
			{
			data.Temperature=DigitADC;
			}
		
		
		
		}
	if (StepMeasure==1)
		{
		ADMUX=0x40;
		data.PhoneCurrentFeedback=DigitADC;
		
		}
	if (StepMeasure==2)
		{
		ADMUX=0x46;
		data.PhoneVoltageFeedback=DigitADC;
		
		}
	if (StepMeasure==3)
		{
	
		if (SetInputsMeasure>2) SetInputsMeasure=0;
		else SetInputsMeasure++;
		
		if (SetInputsMeasure==0)
			{
			ADMUX=0x45;
			}
		if (SetInputsMeasure==1)
			{
			ADMUX=0x44;
			}
		if (SetInputsMeasure==2)
			{
			ADMUX=0x47;
			}
		if (SetInputsMeasure==3)
			{
			ADMUX=0x42;
			}	
		
		data.SourceVoltage=DigitADC;
		MeasureFlag=1;
	
		
		}
	IdleCircle=1;
	}
else IdleCircle=0;
sbi (ADCSRA,ADSC);


}




void filter(struct inputADC* copy,struct inputADC* filteredValue)
{


static int16_t memory[3];

memory[0]=copy->PhoneCurrentFeedback+memory[0]-memory[0]/8;
filteredValue->PhoneCurrentFeedback=memory[0]/8;

memory[1]=copy->AccumCurrent+memory[1]-memory[1]/8;
filteredValue->AccumCurrent=memory[1]/8;



memory[2]=copy->AccumVoltage+memory[2]-memory[2]/4;
filteredValue->AccumVoltage=memory[2]/4;


}












