/* Name: I_O_hardware.c
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#include <stdlib.h>
#include <avr/wdt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <compat/deprecated.h>
#include<avr/sleep.h>

#include "I_O_hardware.h"


//--------------------------------------------------------------------------------------------------------------------

void ioinit (void)
{
uint8_t o,p;


DDRD=0b11111111;
DDRB=0b11000100;

ACSR=_BV(ACD);
TCCR0A=_BV(COM0A1)|_BV(WGM01)|_BV(WGM00);
	TCCR0B=_BV(CS00);

TCCR1A=_BV(WGM11)|_BV(COM1B1);
	TCCR1B=_BV(WGM12)|_BV(WGM13)|_BV(CS10);
	ICR1=100;



TCCR2A=_BV(COM2B1)|_BV(WGM21)|_BV(WGM20);
TCCR2B=_BV(WGM22)|_BV(CS20);


OCR2A=130;

ADCSRA=_BV(ADEN)|_BV(ADIE)|_BV(ADPS1)|_BV(ADPS0); // clock frequency 1MHz

sbi (ADCSRA,ADSC);
while (bit_is_set (ADCSRA,ADSC));
	o=ADCL;
	p=ADCH;
wdt_reset ();
wdt_enable(WDTO_15MS);


sbi (MCUCR,SE);
sei();
}