/* Name: I_O_hardware.h
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef _I_O_HARDWARE_H_
#define _I_O_HARDWARE_H_

void ioinit (void);


# define INTERRUPT_ADC_DISABLE		cbi (ADCSRA,ADIE)
# define INTERRUPT_ADC_ENABLE		sbi (ADCSRA,ADIE)

#define SET_05A						bit_is_set(PINB,0)
#define SET_52V						bit_is_set(PINB,1)

#define SOURCE_PWM_OFF				cbi (DDRD,6)
#define SOURCE_PWM_ON				sbi (DDRD,6)


#define LI_LED_ON	sbi(PORTD,4)
#define LI_LED_OFF	cbi(PORTD,4)

#define SLA_6V_LED_ON	sbi(PORTD,2)
#define SLA_6V_LED_OFF	cbi(PORTD,2)

#define SLA_12V_LED_ON	sbi(PORTD,1)
#define SLA_12V_LED_OFF	cbi(PORTD,1)

#define NIMH_LED_ON		sbi(PORTD,0)
#define NIMH_LED_OFF	cbi(PORTD,0)

#define LED_FULL_ON		sbi(PORTD,7)
#define LED_FULL_OFF	cbi(PORTD,7)
#define LED_NORMAL_ON	sbi(PORTD,5)
#define LED_NORMAL_OFF	cbi(PORTD,5)
#define LED_EMPTY_ON	sbi(PORTB,7)
#define LED_EMPTY_OFF	cbi(PORTB,7)

#define LED_CURRENT_ON	sbi(PORTB,6)
#define LED_CURRENT_OFF	cbi(PORTB,6)

#endif