/* Name: accum_charge_control.h
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
 
#ifndef __ACCUM_CHARGE_CONTROL_H__
#define __ACCUM_CHARGE_CONTROL_H__

uint8_t accumChargeControl(int16_t aAccumVoltage,int16_t aJumperVoltage,int16_t aAccumCurrent,int16_t aTemperature);
void initArray ();

enum {ESLALIACCUM=0,EWITHOUTACCUM,ENIMNHACCUM};


#define LI_ACCUM_EMPTY  	accum_voltage_matrix [0]
#define LI_ACCUM_NORMAL  	accum_voltage_matrix [1]
#define LI_ACCUM_FULL  		accum_voltage_matrix [2]
#define SLA_6V_FULL			accum_voltage_matrix [3]
#define SLA_6V_NORMAL		accum_voltage_matrix [4]
#define SLA_6V_EMPTY		accum_voltage_matrix [5]
#define SLA_12V_FULL		accum_voltage_matrix [6]
#define SLA_12V_NORMAL		accum_voltage_matrix [7]
#define SLA_12V_EMPTY		accum_voltage_matrix [8]
#define NICD_FULL			accum_voltage_matrix [9]
#define NICD_NORMAL			accum_voltage_matrix [10]
#define NICD_EMPTY			accum_voltage_matrix [11]



#endif