/* Name: battery_calc.h
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

# ifndef BATTERY_CALC_H
# define BATTERY_CALC_H

#define LI_VOLTAGE_EMPTY		2.9
#define LI_VOLTAGE_NORMAL		3.9
#define LI_VOLTAGE_FULL			4.1
#define SLA_6V_VOLTAGE_EMPTY	5.8
#define SLA_6V_VOLTAGE_NORMAL	6.2
#define SLA_6V_VOLTAGE_FULL		7.2
#define SLA_12V_VOLTAGE_EMPTY	11.2
#define SLA_12V_VOLTAGE_NORMAL	12.6
#define SLA_12V_VOLTAGE_FULL	14.6
#define NICD_VOLTAGE_EMPTY		4.0
#define NICD_VOLTAGE_NORMAL		5.2
#define NICD_VOLTAGE_FULL		5.8


// voltage on power pin of controller
#define AVR_POWER_VOLTAGE 				5.03






// R3,R14 value in kOhm
#define Rinput							24.0

// R10, R15 value in kOhm
#define Rdivide							10.0

// services macroses

#define K_ADC							1024/AVR_POWER_VOLTAGE

#define K_INPUT_DEVIDER					(Rdivide/(Rinput+Rdivide))

// DELTA_AMPERHOUR=5mAh

#define DELTA_AMPERHOUR					5000


// off level solar panel when work without accumulator
#define VOLTAGE_LIMIT					14.8

#define ADC_VOLTAGE_LIMIT    		VOLTAGE_LIMIT*K_INPUT_DEVIDER*K_ADC

		

# endif