/* Name: power_supply_control.c
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#include <inttypes.h>
#include <avr/io.h>
#include <compat/deprecated.h>

#include "I_O_hardware.h"
#include "power_supply_control.h"

void powerSupplyControl(int16_t aSourceVoltage)
{
static int16_t Integr;
int16_t error,PWM;


// 7.2V is level auxiliary buster off


	{	
	if (aSourceVoltage<100) 
		{
	
		SOURCE_PWM_ON;

		error=62-aSourceVoltage;	// 6.5V is stabilizator level
							Integr=Integr+error;
						
							if (Integr>8000)
									Integr=8000;
								if (Integr<0)
										Integr=0;
							
							PWM=error+Integr/32;
							if (PWM>220) PWM=220;
							if (PWM<20) PWM=20;
							OCR0A=PWM;
		}
	else
		{
		SOURCE_PWM_OFF;
		Integr=160;
		}
	}	
	

}