/* Name: solar_MPPTracker.c
 * Project: Sun_chargeV2.1
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2014-20-01
 * Tabsize: 4
 * Copyright: (c) 2014 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Sun_charge.
 *
 *   Sun_charge is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Sun_charge is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Sun_charge.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#include <avr/io.h>
#include <inttypes.h>
#include <compat/deprecated.h>

#include "main.h"
#include "I_O_hardware.h"
#include "phone_charger_control.h"


void currentLevelIndicator (int16_t aCurrentPhone,int16_t aCurrentAccum,int16_t aJumperVoltage)
{
static uint16_t LedDelay,FrequencyDevider;
static int16_t filteredCurrent,setTime;
int16_t Current;
	if (FrequencyDevider) FrequencyDevider--;
	else 
	
			{
			FrequencyDevider=400;
			
			if (aJumperVoltage>190&&aJumperVoltage<600) Current=(int16_t)PHONE_ZERO_CURRENT_POINT-aCurrentPhone;
			else
				{
				
			
				Current=aCurrentAccum;
				}
		
			
			filteredCurrent=filteredCurrent+Current-filteredCurrent/16;	


			
			if (filteredCurrent>16)
			{
			
			
			if (LedDelay<(setTime/2)) LED_CURRENT_ON;
			else LED_CURRENT_OFF;
			
			if (LedDelay<setTime) LedDelay++;
			else 
				{
				LedDelay=0;
				if (filteredCurrent>684) filteredCurrent=684;
				setTime=(700-filteredCurrent)/8;
				}
			}
			else LED_CURRENT_OFF;
			}
}


/*--------------------------------------------------------------------------------------------------------------------------------------------------------------
 find optimal width pulse of PWM that give max load current, restart charge process after fall charger current (in cloudy weather)
 call frequency 30Hz
 max PWM=255; */

void solar_MPPTracker (uint8_t trackerMode,int16_t aAccumVoltage) 
{
int16_t Delta_Current,Delta_Output;//,Current;
static  int16_t SumPWM=50, Current_Last,Output_Last,Step=4,clockDelay;
static  uint8_t Fall_Flope,Rise_Slope,Count_Step;



if (clockDelay) clockDelay--;
else 
	{

	clockDelay=400;
	


	
	if (trackerMode==WORK_TRACKER)

		{
			Delta_Current=aAccumVoltage-Current_Last;
			Current_Last=aAccumVoltage;
			Delta_Output=SumPWM-Output_Last;
			Output_Last=SumPWM;

			if (((Delta_Output>0)&&(Delta_Current>0))||((Delta_Output<0)&&(Delta_Current<0)))
				{
				
				Step=4;
				if (Fall_Flope) Count_Step=4;
				Rise_Slope=1;
				Fall_Flope=0;
				if (Count_Step) Step=2;
				}
			if (((Delta_Output<0)&&(Delta_Current>0))||((Delta_Output>0)&&(Delta_Current<0)))
				{
				Step=-4;
				if (Rise_Slope) Count_Step=4;
				Fall_Flope=1;
				Rise_Slope=0;
				if (Count_Step) Step=-2;
				}
				
			if (Count_Step) Count_Step--;
			SumPWM=SumPWM+Step;
			
			if (SumPWM>87) 
				{
				SumPWM=87;
				Step=-4;
				

				}

			if (SumPWM<20) 
				{
				SumPWM=20;
				Step=4;
				
				}
		
			
			OCR1B=SumPWM;
		

		}

	}

if (trackerMode==STOP_TRACKER)
	{
			
	
	OCR1B=0;
	}
	

}